clear all
% close all
clc

%%%%% Choose test signal (1 for voiced fricative, 0 for voiceless fricative)
voiced = 0;
fname = ['audio/sample',num2str(voiced,'%.2d'),'.wav'];

%%%%% Set parameters for the decomposition, set param = [] for default values
param = [];

[ymix, fs] = wavread(fname);
[yp, yn, f0] = hn_sep(ymix, fs, param); % Separation

% %%%
y = [ymix(:);yp(:);yn(:)];
nf = length(ymix);
tvec = (0:nf-1)/fs;

%%% Compute VQ from time envelopes
h = fir1(1001,25/(fs/2),'low');h = h/sum(h);
e = filter(h,1,y.^2);
e = filter(h,1,e(end:-1:1));
e = real(sqrt(2*e(end:-1:1)));
stp = e(nf+1:2*nf); %time envelope of periodic components
stn = e(2*nf+1:end); %time envelope of aperiodic components
stmix = stp+stn;
stmix(stmix<=0) = stp(stmix<=0);
vq = 100*stp./stmix;

% Plot time signals
figure; 
h(1)=subplot(511);plot(tvec(1:nf), ymix);
title('Mix signal s(t)')
ylim([-1 1])
h(2)=subplot(512);plot(tvec(1:nf), yp);
title('Periodic signal s_p(t)')
ylim([-1 1])
h(3)=subplot(513);plot(tvec(1:nf), yn);
title('Aperiodic signal s_n(t)')
ylim([-1 1])
h(4)=subplot(514);plot(f0.t, f0.f, 'linewidth',2);  
title('Pitch estimation f0 (Hz)')
hold on;  
h(5)=subplot(515);plot(tvec(1:nf), vq, 'linewidth',2);  
title('Voicing quotient VQ (%)')

hold on;  
ylim([0 100])
linkaxes(h,'x')
xlim([0.1 0.5])
